// UTAUpGWwtn_fndsx version 0.0.1
//
// ̃vO͐X뎁WORLDUTAUGWwG^[itH[XuTv[ 
// WFg[EEB[vX@`͎ʁCʁ`x(EFB-GW)JX^}CYAA
// qxɑΉ̂łB
//
// ---ȉ{̃Rg
//
// G^[itH[XuTv[ WFg[EEB[vX@`͎ʁCʁ`
// l^ł͂߂WORLDUTAUGWłDWORLD 0.0.4KKςĂ̂ŁC
// ̃vOWORLDƂ͕ʕƎvقǂłD
// v`i̐͐番ł̏x\ĂāC850ȏオv`iƔF߂D
// Pt100Ƃ̂́Cv`iƂ͂Ȃʂ̉i{vOɂV@\jłD
#include <stdio.h>
#include <stdlib.h>

#include <windows.h>

#include "world.h"
#include "wavread.h"

#include <math.h>

// 12̂
// 1 ̓t@CiOKj
// 2 o̓t@CiOKj
// 3 KiOKj
// 4 qx
// 5 tOij(OK)
// 6 ItZbg
// 7 
// 8 q
// 9 uN
// 10 {[ (OK)
// 11 W[V (OK)
// 12 e|
// 13 sb`xh

// ̓Vtg [msec]
#define FRAMEPERIOD 2.0

#pragma comment(lib, "winmm.lib")

void createFinalPitch(double *f0, int tLen, double *pitchBend, int bLen, int offset, int fs, double tempo)
{
	int i;
	double *time1, *time2, *pitch;
	int pStep;
	time1 = (double *)malloc(sizeof(double) * tLen);
	time2 = (double *)malloc(sizeof(double) * bLen);
	pitch = (double *)malloc(sizeof(double) * tLen);

	pStep = (int)(60.0 / 96.0 / tempo * fs + 0.5);

	for(i = 0;i < tLen;i++) time1[i] = (double)i * FRAMEPERIOD;
//	for(i = 0;i < bLen;i++) time2[i] = (double)i * 256.0 / (double)fs * 1000.0 + (double)offset;
    for(i = 0;i < bLen;i++) time2[i] = (double)i * pStep / (double)fs * 1000.0;

	interp1(time2, pitchBend, bLen, time1, tLen, pitch);

//	for(i = 0;i < tLen;i++) f0[i] *= pitch[i];
	for(i = (int)(offset*FRAMEPERIOD);i < tLen;i++) f0[i] *= pitch[i];

	for(i = 0;i < tLen;i+=10)
	{
//		printf("%f\n", pitch[i]);
	}

	free(time1); free(time2); free(pitch);
}

int base64decoderForUtau(char x, char y)
{
	int ans1, ans2, ans;

	if(x=='+') ans1 = 62;
	if(x=='/') ans1 = 63;
	if(x>='0' && x <= '9') ans1 = x+4;
	if(x>='A' && x <= 'Z') ans1 = x-65;
	if(x>='a' && x <= 'z') ans1 = x-71;

	if(y=='+') ans2 = 62;
	if(y=='/') ans2 = 63;
	if(y>='0' && y <= '9') ans2 = y+4;
	if(y>='A' && y <= 'Z') ans2 = y-65;
	if(y>='a' && y <= 'z') ans2 = y-71;

	ans = (ans1<<6) | ans2;
	if(ans >= 2048) ans -= 4096;
	return ans;
}

int getF0Contour(char *input, double *output)
{
	int i, j, count, length;
	i = 0;
	count = 0;
	double tmp;

	tmp = 0.0;
	while(input[i] != '\0')
	{
		if(input[i] == '#')
		{ // ʍƂɂĂႢ
			length = 0;
			for(j = i+1;input[j]!='#';j++)
			{
				length = length*10 + input[j]-'0';
			}
			i = j+1;
			for(j = 0;j < length;j++)
			{
				output[count++] = tmp;
			}
		}
		else
		{
			tmp = pow(2.0, (double)base64decoderForUtau(input[i], input[i+1]) / 1200.0);
			output[count++] = tmp;
			i+=2;
		}
	}

	return count;
}

void equalizingPicth(double *f0, int tLen, char *scaleParam, int modulationParam)
{
	int i;
	// ܂ϒl𒲂ׂD
	double averageF0;
	int count;
	int rangeSt, rangeEd;
	double modulation;

	modulation = (double)modulationParam / 100.0;

	averageF0 = 0;
	count = 0;
	rangeSt = max(0, tLen/2 - 50);
	rangeEd = min(tLen-1, tLen/2 + 49);

	for(i = rangeSt;i < rangeEd;i++)
	{
		if(f0[i] != 0.0)
		{
			averageF0 = averageF0 + f0[i];
			count++;
		}
	}
	 
	(count==0)? averageF0 = 0.0: averageF0 /= (double)count;

	int scale;
	int octave;
	double targetF0;
	int bias = 0;

	// ڕWƂ鉹K̓
	if(scaleParam[1] == '#') bias = 1;

	switch(scaleParam[0])
	{
	case 'C':
		scale = -9+bias;
		break;
	case 'D':
		scale = -7+bias;
		break;
	case 'E':
		scale = -5;
		break;
	case 'F':
		scale = -4+bias;
		break;
	case 'G':
		scale = -2+bias;
		break;
	case 'A':
		scale = bias;
		break;
	case 'B':
		scale = 2;
		break;
	}
	octave = scaleParam[1+bias]-'0' - 4;
	targetF0 = 440 * pow(2.0,(double)octave) * pow(2.0, (double)scale/12.0);

	double tmp;
	
	if(averageF0 != 0.0)
	{
		for(i = 0;i < tLen;i++)
		{
			if(f0[i] != 0.0)
			{
				tmp = (f0[i]-averageF0)*modulation + averageF0;
				f0[i] = tmp * targetF0 / averageF0;
			}
		}
	}
}


int stretchTime(double *f0, int tLen, int fftl, double **residualSpecgram,
				 double *f02, int tLen2, double **residualSpecgram2, int st, int ed, int Length2, double velocity)
{
	int i, j, k;//, count;
//    count = 0;

	int st2, ed2;
	double ratio; 

	ratio = pow(2.0, (1.0 - (velocity / 100.0))); //qLk

	st2 = min(tLen2, (int)(st * ratio + 0.5));  //Lk̎qt[
    ed2 = min(tLen2, (int)(Length2 + 0.5));     //̃Tv
	// O  
	for(i = 0;i < st2;i++)
	{
		k = max(0, min(tLen-1, int(i/ratio)));
		f02[i] = f0[k];
		for(j = 0;j <= fftl/2;j++) residualSpecgram2[i][j] = residualSpecgram[k][j];
	}
	// 㔼i[vL΂j
	i = st2;
	while(i < ed2)
	{
		for(k = st; k < ed-2; k++)
		{
			if(i > ed2-1) break;
			f02[i] = f0[k];
			for(j = 0;j <= fftl/2;j++) residualSpecgram2[i][j] = residualSpecgram[k][j];
			i++;
		}
		for(k = ed-1; k > st; k--)
		{
			if(i > ed2-1) break;
			f02[i] = f0[k];
			for(j = 0;j <= fftl/2;j++) residualSpecgram2[i][j] = residualSpecgram[k][j];
			i++;
		}
	}
/*
    //㔼iUTAUL΂j
	double wratio;
	(tLen > st)? wratio = (double)(tLen2 - st2) / (double)(tLen - st): 1.0;
	for(i = st2;i < ed;i++)
	{
		k = max(0, min(tLen-1, int((double)(i-st2)/wratio) + st));
		f02[i] = f0[k];
		for(j = 0;j <= fftl/2;j++) residualSpecgram2[i][j] = residualSpecgram[k][j];
	}
*/
/*
	
	// O
	for(i = 0;i < st;i++)
	{
		if(count >= tLen2) break;
		f02[count] = f0[i];
		for(j = 0;j <= fftl/2;j++) residualSpecgram2[count][j] = residualSpecgram[i][j];
		count++;
	}
	for(i = 0;i < loop;i++)
	{
		for(j = st;j < ed;j++)
		{
			if(count >= tLen2) break;
			f02[count] = f0[j];
			for(k = 0;k < fftl/2;k++) residualSpecgram2[count][k] = residualSpecgram[j][k];
			count++;
//	printf("%d %d %d\n", tLen2, count, loop);
		}
		for(j = ed;j > st;j--)
		{
			if(count >= tLen2) break;
			f02[count] = f0[j];
			for(k = 0;k < fftl/2;k++) residualSpecgram2[count][k] = residualSpecgram[j][k];
			count++;
//	printf("%d %d %d\n", tLen2, count, loop);
		}
	}
	for(i = st;i < tLen;i++)
	{
		if(count >= tLen2) break;
		f02[count] = f0[i];
		for(j = 0;j < fftl/2;j++) residualSpecgram2[count][j] = residualSpecgram[i][j];
		count++;
	}
*/
//	return count;
	return ed2;
}

int main(int argc, char *argv[])
{
	int i;

	double *x,*f0,*t,*y;
	double **residualSpecgram;
	int fftl;

	int signalLen;
	int tLen;

	if(argc < 3) 
	{
		printf("error: ̐słD\n");
		return 0;
	}

	/*
	printf("argc:%d\n", argc);
	for(i = 0;i < argc-1;i++)
		printf("%s\n", argv[i]);
	//*/

	FILE *fp;

	int offset;
	int edLengthMsec;
	offset = atoi(argv[6]);
	edLengthMsec = atoi(argv[9]);

	int fs, nbit;
//	x = wavread(argv[1], &fs, &nbit, &signalLen);
	x = wavread(argv[1], &fs, &nbit, &signalLen, &offset, &edLengthMsec);

	if(x == NULL)
	{
		printf("error: w肳ꂽt@C݂͑܂D\n");
		return 0;
	}

	printf("File information\n");
	printf("Sampling : %d Hz %d Bit\n", fs, nbit);
	printf("Length %d [sample]\n", signalLen);
	printf("Length %f [sec]\n", (double)signalLen/(double)fs);

	// F0͉Tv邩OɌvZD
	tLen = getSamplesForDIO(fs, signalLen, FRAMEPERIOD);
	f0 = (double *)malloc(sizeof(double)*tLen);
	t  = (double *)malloc(sizeof(double)*tLen);
	// f0 estimation by DIO
	DWORD elapsedTime;

	printf("\nAnalysis\n");
	elapsedTime = timeGetTime();
	dio(x, signalLen, fs, FRAMEPERIOD, t, f0);
	printf("DIO: %d [msec]\n", timeGetTime() - elapsedTime);

	fftl = getFFTLengthForStar(fs);

	residualSpecgram	= (double **)malloc(sizeof(double *) * tLen);
	for(i = 0;i < tLen;i++) residualSpecgram[i] = (double *)malloc(sizeof(double) * (fftl/2+1));

	// wW̕
	elapsedTime = timeGetTime();
	pt100(x, signalLen, fs, t, f0, residualSpecgram);
	printf("PLATINUM: %d [msec]\n", timeGetTime() - elapsedTime);

	// Ԓ̐Lk
	int /*offset,*/ endOffset;
	endOffset = 0;
	int lengthMsec, stLengthMsec, /*edLengthMsec,*/ inputLengthMsec;
//	offset = atoi(argv[6]);                   //ItZbg͕͎ɃNbsOς
//	double ratio;
	double velocity;
	inputLengthMsec = (int)(tLen*FRAMEPERIOD);//̎gp\Ȓ
	lengthMsec = atoi(argv[7])+endOffset;     //v
	stLengthMsec = atoi(argv[8]);             //q
//	edLengthMsec = 0;                         
	velocity = (double)atoi(argv[4]);         //qx 
//	edLengthMsec = atoi(argv[9]);             //uN͕͎ɃNbsOς
//	if(edLengthMsec < 0) // ̏ꍇoffset̋
//	{
//		edLengthMsec = inputLengthMsec - (offset-edLengthMsec);
//	}

//	stLengthMsec = max(stLengthMsec, offset); // IvV
//	int loop;
	//loop = (lengthMsec-stLengthMsec)/(inputLengthMsec-stLengthMsec-edLengthMsec);
//	loop = (lengthMsec-stLengthMsec)/(edLengthMsec - stLengthMsec)+1;
//	ratio = (double)(lengthMsec + offset - stLengthMsec) / (double)(inputLengthMsec - stLengthMsec - edLengthMsec);
//	ratio = (double)(lengthMsec - stLengthMsec) / (double)(edLengthMsec - stLengthMsec);
	// p^̃m
	double *fixedF0;
	double **fixedResidualSpecgram;
	int tLen2;
//	tLen2 = (int)(0.5+(double)(lengthMsec+offset)/FRAMEPERIOD); //C
//	tLen2 = (int)(0.5+(double)(lengthMsec*2)/FRAMEPERIOD);
    tLen2 = (int)(0.5+(double)(lengthMsec*2)/FRAMEPERIOD);

	fixedF0					= (double *) malloc(sizeof(double)   * tLen2);
	fixedResidualSpecgram	= (double **)malloc(sizeof(double *) * tLen2);
	for(i = 0;i < tLen2;i++) fixedResidualSpecgram[i]	= (double *)malloc(sizeof(double) * (fftl/2+1));

	// sb`xh̎擾
	double *pitchBend;
	int bLen;
	double tempo = 120;
	char *cp;
	if (argc>12){
		cp = argv[12];
		sscanf(cp + 1, "%lf", &tempo);
	}
	int pStep;
	pStep = (int)(60.0 / 96.0 / tempo * fs + 0.5);
	bLen = (int)(lengthMsec * fs / 1000) / pStep + 1;

//	bLen = lengthMsec * 125/ (tempo * 5)+1;
	pitchBend = (double *)malloc(sizeof(double) * bLen);
	if((argc<=12) || (argv[13] == NULL))
	{
//		for(i = 0;i < tLen2;i++) pitchBend[i] = 1.0;
		for(i = 0;i < bLen;i++) pitchBend[i] = 1.0;
//		bLen = tLen2; // ꂵI͖ővH 2011/12/29
	}
	else
	{
		int bLen2;
		bLen2 = getF0Contour(argv[13], pitchBend);
		for(i = bLen2;i < bLen;i++) pitchBend[i] = 1.0;
	}

	// ŏIg`̃m
	int signalLen2;
//	signalLen2 = (int)((lengthMsec+offset)/1000.0*(double)fs);
	signalLen2 = (int)((lengthMsec       )/1000.0*(double)fs);
	y  = (double *)malloc(sizeof(double)*signalLen2);
	for(i = 0;i < signalLen2;i++) y[i] = 0.0;
//	printf("length:%d, %f\n",signalLen2, (double)signalLen2/(double)fs*1000.0);
//	printf("%d, %d, %d\n",lengthMsec, offset, fs);


	// ̑OF0̑ ()
	equalizingPicth(f0, tLen, argv[3], atoi(argv[11]) );
//	stretchTime(f0, tLen, fftl, residualSpecgram, 
//				 fixedF0, tLen2, fixedResidualSpecgram, stLengthMsec/(int)FRAMEPERIOD, ratio);
	int st, ed;

	/*
	st = (stLengthMsec + (inputLengthMsec-edLengthMsec)/3);
	ed = (stLengthMsec + 2*(inputLengthMsec-edLengthMsec)/3);
	*/
	st = (stLengthMsec);
	ed = (edLengthMsec);

	tLen2 = stretchTime(f0, tLen, fftl, residualSpecgram, 
			//	 fixedF0, tLen2, fixedResidualSpecgram, st/(int)FRAMEPERIOD, ed/(int)FRAMEPERIOD, loop);
			//	 fixedF0, tLen2, fixedResidualSpecgram, st/(int)FRAMEPERIOD, min(ed/(int)FRAMEPERIOD, tLen-1), loop);
			     fixedF0, tLen2, fixedResidualSpecgram, st/(int)FRAMEPERIOD, min(ed/(int)FRAMEPERIOD, tLen-1), lengthMsec, velocity);
	//createFinalPitch(fixedF0, tLen2, pitchBend, bLen, (int)(offset/FRAMEPERIOD), fs);
	createFinalPitch(fixedF0, tLen2, pitchBend, bLen, 0, fs, tempo);

	// 
	printf("\nSynthesis\n");
	elapsedTime = timeGetTime();
	synthesisPt100(fixedF0, tLen2, fixedResidualSpecgram, fftl, FRAMEPERIOD, fs, y, signalLen2);
	printf("WORLD: %d [msec]\n", timeGetTime() - elapsedTime);
	// ItZbg̐ݒ
//	offset = (int)((double)(offset+endOffset)/1000.0*(double)fs);
	signalLen2 = (int)((lengthMsec)/1000.0*(double)fs);
//	signalLen2 -= offset;
//	for(i = 0;i < signalLen2;i++) y[i] = y[i+offset];

//	printf("%d\n", signalLen2);
//	printf("%f %d\n", (double)signalLen2/(double)fs*1000, offset);
//	getch();


	// t@C̏o (eɂ͊֌WȂ)
	char header[44];
	short *output;
	double maxAmp;
	output = (short *)malloc(sizeof(short) * signalLen2);
 
	// U̐K
	maxAmp = 0.0;
	double volume;
	volume = (double)atoi(argv[10]) / 100.0;
	for(i = 0;i < signalLen2;i++) maxAmp = maxAmp < abs(y[i]) ? abs(y[i]) : maxAmp;
	for(i = 0;i < signalLen2;i++) output[i] = (short)(32768.0*(y[i]*0.5 * volume/maxAmp));

	fp = fopen(argv[1], "rb");
	fread(header, sizeof(char), 44, fp);
	fclose(fp);

	header[36] = 'd'; header[37] = 'a'; header[38] = 't'; header[39] = 'a';

	fp = fopen(argv[2],"wb");
	fwrite(header, sizeof(char), 44, fp);
	fwrite(output, sizeof(short), signalLen2, fp);
	fseek(fp, 40, SEEK_SET);
	signalLen2*=2;
	fwrite(&signalLen2, sizeof(int), 1, fp);
	fclose(fp);
	free(output);

	free(pitchBend);
	free(x); free(t); free(f0); free(fixedF0); free(y);
	for(i = 0;i < tLen;i++)
	{
		free(residualSpecgram[i]);
	}
	for(i = 0;i < tLen2;i++)
	{
		free(fixedResidualSpecgram[i]);
	}
	free(fixedResidualSpecgram);
	free(residualSpecgram); 

	printf("complete.\n");
	return 0;
}