#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "wavread.h"

#pragma warning(disable:4996)

/* wavread֐̈ڐA */
double * wavread(char* filename, int *fs, int *Nbit, int *waveLength, int *offset, int *endbr)
{
	FILE *fp;
	char dataCheck[5]; // ߂
	unsigned char forIntNumber[4];
	double tmp, signBias, zeroLine;
	int quantizationByte;
	double *waveForm;

	dataCheck[4] = '\0'; // ƍ̂߁CŌɏID
//	fp = fopen(filename, "rb");
	fp = fopen(filename, "rb");
	if(NULL == fp) 
	{
		printf("t@C̃[hɎs\n");
		return NULL;
	}
	//wb_̃`FbN
	fread(dataCheck, sizeof(char), 4, fp); // "RIFF"
	if(0 != strcmp(dataCheck,"RIFF"))
	{
		fclose(fp);
		printf("wb_RIFFs\n");
		return NULL;
	}
	fseek(fp, 4, SEEK_CUR); // 4oCg΂
	fread(dataCheck, sizeof(char), 4, fp); // "WAVE"
	if(0 != strcmp(dataCheck,"WAVE"))
	{
		fclose(fp);
		printf("wb_WAVEs\n");
		return NULL;
	}
	fread(dataCheck, sizeof(char), 4, fp); // "fmt "
	if(0 != strcmp(dataCheck,"fmt "))
	{
		fclose(fp);
		printf("wb_fmt s\n");
		return NULL;
	}
	fread(dataCheck, sizeof(char), 4, fp); //1 0 0 0
	if(!(16 == dataCheck[0] && 0 == dataCheck[1] && 0 == dataCheck[2] && 0 == dataCheck[3]))
	{
		fclose(fp);
		printf("wb_fmt (2)s\n");
		return NULL;
	}
	fread(dataCheck, sizeof(char), 2, fp); //1 0
	if(!(1 == dataCheck[0] && 0 == dataCheck[1]))
	{
		fclose(fp);
		printf("tH[}bgIDs\n");
		return NULL;
	}
	fread(dataCheck, sizeof(char), 2, fp); //1 0
	if(!(1 == dataCheck[0] && 0 == dataCheck[1]))
	{
		fclose(fp);
		printf("XeIɂ͑ΉĂ܂\n");
		return NULL;
	}

	// TvOg
	fread(forIntNumber, sizeof(char), 4, fp);
	*fs = 0;
	for(int i = 3;i >= 0;i--)
	{
		*fs = *fs*256 + forIntNumber[i];
	}
	// ʎqrbg
	fseek(fp, 6, SEEK_CUR); // 6oCg΂
	fread(forIntNumber, sizeof(char), 2, fp);
	*Nbit = forIntNumber[0];
	// wb_
	int dummy;
	fread(dataCheck, sizeof(char), 4, fp); // "data"
	while(0 != strcmp(dataCheck,"data"))
	{
		fread(&dummy, sizeof(char), 4, fp);
		fseek(fp, dummy, SEEK_CUR); // ֌Wȃ`Nǂݔ΂
		fread(dataCheck, sizeof(char), 4, fp); // "data"
//		fclose(fp);
//		printf("wb_datas\n");
//		return NULL;
	}
	// Tv_̐
	fread(forIntNumber, sizeof(char), 4, fp); // "data"
	*waveLength = 0;
	for(int i = 3;i >= 0;i--)
	{
		*waveLength = *waveLength*256 + forIntNumber[i];
	}
	*waveLength /= (*Nbit/8);

	if(*endbr < 0) // ̏ꍇoffset̋
	{
		*endbr = (*waveLength * 1000 / *fs) - (*offset-*endbr);
	}

	int st, ed;
	st = int(*offset * *fs / 1000); 
	ed = *waveLength - int(max(0, *endbr - 100) * *fs / 1000);
	st = min(st, *waveLength-1);
	ed = min(ed, *waveLength-1);
	*endbr = (*waveLength * 1000 / *fs) - *offset - *endbr;
	*offset = 0;
	*waveLength = (ed - st + 1);

	// g`o
	waveForm = (double *)malloc(sizeof(double) * *waveLength);
	if(waveForm == NULL) return NULL;

	quantizationByte = *Nbit/8;
	zeroLine = pow(2.0,*Nbit-1);
//	for(int i = 0;i < *waveLength;i++)

	fseek(fp, st*quantizationByte, SEEK_CUR);  //X^[gʒu܂œǂݔ΂
	for(int i = 0;i < *waveLength;i++)
	{
		signBias = 0.0;
		tmp = 0.0;
		fread(forIntNumber, sizeof(char), quantizationByte, fp); // "data"
		// ̊mF
		if(forIntNumber[quantizationByte-1] >= 128)
		{
			signBias = pow(2.0,*Nbit-1);
			forIntNumber[quantizationByte-1] = forIntNumber[quantizationByte-1] & 0x7F;
		}
		// f[^̓ǂݍ
		for(int j = quantizationByte-1;j >= 0;j--)
		{
			tmp = tmp*256.0 + (double)(forIntNumber[j]);
		}
		waveForm[i] = (double)((tmp - signBias) / zeroLine);
	}
	// 
	fclose(fp);
	return waveForm;
}

